from abc import ABC, abstractmethod

import discord
from discord.ext import commands


class BotServiceABC(ABC, commands.Bot):

    @abstractmethod
    def __init__(self): pass

    @abstractmethod
    async def start_async(self): pass

    @abstractmethod
    async def stop_async(self): pass
    
    @abstractmethod
    async def on_message(self, message: discord.Message): pass
