import traceback

from cpl_core.configuration import ConfigurationModelABC
from cpl_core.console import Console
from cpl_query.extension import List
from gismo_core.configuration.server_settings import ServerSettings


class BotSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._prefix: str = ''
        self._servers: List[ServerSettings] = List()

    @property
    def prefix(self) -> str:
        return self._prefix
    
    @property
    def servers(self) -> List[ServerSettings]:
        return self._servers

    def from_dict(self, settings: dict):
        try:
            self._prefix = settings['Prefix']
            servers = List(ServerSettings)
            for s in settings['Servers']:
                st = ServerSettings()
                st.from_dict(s)
                servers.append(st)
            self._servers = servers
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
